;'use strict';var MessageDB=(function(){var DB_NAME='wappush';var DB_VERSION=1;var MESSAGE_STORE_NAME='message';var KEY_PATH='timestamp';var ID_INDEX='id';var ID_INDEX_KEYPATH='id';var db=null;function mdb_transactionPromise(transaction,state){return new Promise(function(resolve,reject){transaction.oncomplete=function mdb_onTransactionComplete(event){resolve(state&&state.result);};transaction.onerror=function mdb_onTransactionError(event){reject(event.target.error);};});}
function mdb_open(){if(db){return Promise.resolve(db);}
var indexedDB;try{indexedDB=window.indexedDB||window.webkitIndexedDB||window.mozIndexedDB||window.msIndexedDB;}catch(e){return Promise.reject(e);}
if(!indexedDB){return Promise.reject(new Error('IndexedDB is not available'));}
return new Promise(function(resolve,reject){var req;try{req=indexedDB.open(DB_NAME,DB_VERSION);}catch(e){reject(e);return;}
req.onsuccess=function mdb_opened(event){db=event.target.result;resolve(db);};req.onerror=function mdb_openError(event){reject(event.target.error);};req.onupgradeneeded=function mdb_upgradeNeeded(event){var db=event.target.result;if(event.oldVersion===0){var store=db.createObjectStore(MESSAGE_STORE_NAME,{keyPath:KEY_PATH});store.createIndex(ID_INDEX,ID_INDEX_KEYPATH,{unique:false});}};});}
function mdb_processMessage(store,message,status){if(message.action==='delete'){mdb_deleteById(store,message.id);status='discarded';}else{store.put(message);}
return status;}
function mdb_put(message){return mdb_open().then(function mdb_openResolved(db){var state={result:'new'};var transaction=db.transaction(MESSAGE_STORE_NAME,'readwrite');var promise=mdb_transactionPromise(transaction,state);var store=transaction.objectStore(MESSAGE_STORE_NAME);if(!message.id){store.put(message);return promise;}
if(!message.created){state.result=mdb_processMessage(store,message,state.result);return promise;}
var index=store.index(ID_INDEX);var req=index.openCursor(IDBKeyRange.only(message.id));req.onsuccess=function mdb_cursorSuccess(event){var cursor=event.target.result;if(cursor){var storedMessage=cursor.value;if(storedMessage.created){if(storedMessage.created<message.created){cursor.delete(storedMessage);message.timestamp=storedMessage.timestamp;state.result=mdb_processMessage(store,message,'updated');}else{state.result='discarded';}
return;}
cursor.continue();}else{state.result=mdb_processMessage(store,message,state.result);}};return promise;});}
function mdb_deleteById(store,id){var index=store.index(ID_INDEX);var req=index.openCursor(id);req.onsuccess=function mdb_openCursorSuccess(event){var cursor=event.target.result;if(cursor){var message=cursor.value;cursor.delete().onsuccess=function mdb_onDeleted(){mdb_dispatchEvent('messagedeleted',message);};cursor.continue();}};}
function mdb_retrieve(timestamp){return mdb_open().then(function mdb_openResolved(db){var state={result:null};var transaction=db.transaction(MESSAGE_STORE_NAME,'readwrite');var promise=mdb_transactionPromise(transaction,state);var store=transaction.objectStore(MESSAGE_STORE_NAME);var req=store.get(timestamp.toString());req.onsuccess=function mdb_gotMessage(event){if(event.target.result){var message=event.target.result;state.result=message;if(message.type!='text/vnd.wap.connectivity-xml'){store.delete(message.timestamp);}}};return promise;});}
function mdb_deleteByTimestamp(timestamp){return mdb_open().then(function mdb_deleteCallback(db){var transaction=db.transaction(MESSAGE_STORE_NAME,'readwrite');var promise=mdb_transactionPromise(transaction);var store=transaction.objectStore(MESSAGE_STORE_NAME);timestamp=timestamp.toString();store.get(timestamp).onsuccess=function(event){var message=event.target.result;store.delete(timestamp).onsuccess=function mdb_onDeleted(){mdb_dispatchEvent('messagedeleted',message);};};return promise;});}
function mdb_clear(){return mdb_open().then(function mdb_openResolved(db){var transaction=db.transaction(MESSAGE_STORE_NAME,'readwrite');var promise=mdb_transactionPromise(transaction);var store=transaction.objectStore(MESSAGE_STORE_NAME);store.clear();return promise;});}
function mdb_dispatchEvent(type,target){MessageDB.emit(type,target);}
var mdb_allowedEvents=['messagedeleted'];return EventDispatcher.mixin({put:mdb_put,retrieve:mdb_retrieve,deleteByTimestamp:mdb_deleteByTimestamp,clear:mdb_clear},mdb_allowedEvents);})();