define(["require","exports","module","lib/create-thumbnail-image","debug","views/preview-gallery","lib/prepare-preview-blob","lib/resize-image-and-save","lib/string-utils","lib/bind-all","CustomDialog"],function(e,i,t){"use strict";function n(e){p(this),this.app=e,this.settings=e.settings,this.dialog=e.dialog||d,this.resizeImageAndSave=a,this.bindEvents(),this.configure(),o("initialized")}var s=e("lib/create-thumbnail-image"),o=e("debug")("controller:preview-gallery"),r=e("views/preview-gallery"),h=e("lib/prepare-preview-blob"),a=e("lib/resize-image-and-save"),l=e("lib/string-utils"),p=e("lib/bind-all"),d=e("CustomDialog");t.exports=function(e){return new n(e)},t.exports.PreviewGalleryController=n,n.prototype.bindEvents=function(){this.app.on("storage:itemdeleted",this.onItemDeleted),this.app.on("storage:changed",this.onStorageChanged),this.app.on("preview",this.openPreview),this.app.on("newmedia",this.onNewMedia),this.app.on("hidden",this.onHidden),o("events bound")},n.prototype.configure=function(){this.currentItemIndex=0,this.items=[],this.thumbnailItem=null;var e=window.devicePixelRatio;this.thumbnailSize={width:this.settings.previewGallery.get("thumbnailWidth")*e,height:this.settings.previewGallery.get("thumbnailHeight")*e}},n.prototype.openPreview=function(){if(!this.app.activity.pick&&!this.view){var e=window.CONFIG_MAX_IMAGE_PIXEL_SIZE;this.view=new r,this.view.maxPreviewSize=e,this.view.render().appendTo(this.app.el),this.view.on("click:gallery",this.onGalleryButtonClick),this.view.on("click:share",this.shareCurrentItem),this.view.on("click:delete",this.deleteCurrentItem),this.view.on("click:back",this.closePreview),this.view.on("swipe",this.handleSwipe),this.view.on("click:options",this.onOptionsClick),this.view.on("loadingvideo",this.app.firer("busy")),this.view.on("playingvideo",this.app.firer("ready"));var i=this.app.inSecureMode;this.view.set("secure-mode",i),this.view.open(),this.previewItem(),this.app.emit("previewgallery:opened")}},n.prototype.closePreview=function(){this.thumbnailItem!==this.items[0]&&this.updateThumbnail(),this.view&&(this.currentItemIndex=0,this.view.close(),this.view.destroy(),this.view=null),this.app.emit("previewgallery:closed")},n.prototype.onGalleryButtonClick=function(){if(!this.app.inSecureMode){var e=window.MozActivity;this.mozActivity=new e({name:"browse",data:{type:"photos"}})}},n.prototype.onOptionsClick=function(){this.app.inSecureMode||this.view.showOptionsMenu()},n.prototype.shareCurrentItem=function(){if(!this.app.inSecureMode){var e=this.currentItemIndex,i=this.items[e],t=i.isVideo?"video/*":"image/*",n=l.lastPathComponent(i.filepath),s=function(e){var s=new window.MozActivity({name:"share",data:{type:t,number:1,blobs:[e],filenames:[n],filepaths:[i.filepath]}});s.onerror=function(e){console.warn("Share activity error:",s.error.name)}};if(i.isVideo)return void s(i.blob);var o=this;this.stopItemDeletedEvent=!0,this.resizeImageAndSave({blob:i.blob,size:this.settings.activity.get("maxSharePixelSize")},function(e){o.stopItemDeletedEvent=!1,s(e)})}},n.prototype.deleteCurrentItem=function(){function e(){r.hide()}function i(){r.hide(),h.updatePreviewGallery(n),s.isVideo?h.app.emit("previewgallery:deletevideo",o):h.app.emit("previewgallery:deletepicture",o)}if(!this.app.inSecureMode){var t,n=this.currentItemIndex,s=this.items[n],o=s.filepath,r=this.dialog,h=this;t=s.isVideo?"delete-video?":"delete-photo?",r.show("",t,{title:"cancel",callback:e},{title:"delete",callback:i,recommend:!1})}},n.prototype.updatePreviewGallery=function(e){if(this.items.splice(e,1),0===this.items.length)this.closePreview();else{e==this.items.length&&(this.currentItemIndex=this.items.length-1);var i=this.view?!0:!1;i&&this.previewItem()}},n.prototype.handleSwipe=function(e){"left"===e?this.next():"right"===e&&this.previous()},n.prototype.next=function(){this.currentItemIndex<this.items.length-1&&(this.currentItemIndex+=1,this.previewItem())},n.prototype.previous=function(){this.currentItemIndex>0&&(this.currentItemIndex-=1,this.previewItem())},n.prototype.onNewMedia=function(e){function i(e){t.items.unshift(e),t.updateThumbnail()}if(!this.app.activity.pick){var t=this;e.isVideo?i(e):h(e.blob,function(t){t.blob=e.blob,t.filepath=e.filepath,i(t)})}},n.prototype.previewItem=function(){var e=this.currentItemIndex,i=this.items[e];this.view.updateCountText(e+1,this.items.length),i.isVideo?this.view.showVideo(i):this.view.showImage(i)},n.prototype.onStorageChanged=function(e){"unavailable"===e&&(this.configure(),this.updateThumbnail())},n.prototype.onItemDeleted=function(e){if(!this.stopItemDeletedEvent){for(var i=-1,t=e.path,n=0;n<this.items.length;n++)if(this.items[n].filepath===t){i=n;break}n!==this.items.length&&this.updatePreviewGallery(i)}},n.prototype.onHidden=function(){this.app.inSecureMode&&(this.configure(),this.updateThumbnail()),this.closePreview()},n.prototype.updateThumbnail=function(){function e(e){t.app.emit("newthumbnail",e)}var i,t=this,n=this.thumbnailItem=this.items[0]||null;if(null===n)return void this.app.emit("newthumbnail",null);if(n.isVideo)i=n.poster.blob,n=n.poster;else{if(n.preview){var o=n.width/n.height,r=n.preview.width/n.preview.height;Math.abs(o-r)<.01&&(i=n.blob.slice(n.preview.start,n.preview.end,"image/jpeg"))}i||(i=n.blob)}s(i,n,this.thumbnailSize,e)}});