;;;;'use strict';(function(exports){const APPS_IN_ICON=Common.APPS_IN_ICON;function WebResult(data,gridItemFeatures){data.emeId=data.id;data.url=data.id=data.appUrl;data.renderer=GridIconRenderer.TYPE.CLIP;return{identifier:data.appUrl,type:'webResult',data:data,features:gridItemFeatures};}
function PinnedHomeIcon(identifier){return{identifier:identifier,type:'homeIcon'};}
function BaseCollection(props){this.id=props.id||null;this.name=props.name||'';this.nonTranslatable=props.nonTranslatable||null;this.icon=props.icon||null;this.pinned=props.pinned||[];this.webResults=[];this.webicons=props.webicons||[];this.background=props.background||{};this.originalProps={pinned:props.pinned?props.pinned.slice():[],background:props.background||{}};if(window.SearchDedupe){this.dedupe=new SearchDedupe();}}
BaseCollection.create=function create(data){if(data.categoryId){return new CategoryCollection(data);}else if(data.query){return new QueryCollection(data);}
return null;};BaseCollection.prototype={get iconsReady(){return this.pinned.length+this.webicons.length>=APPS_IN_ICON;},get backgroundReady(){return this.background&&this.background.blob;},get localizedName(){if(this.nonTranslatable){return this.name;}
var l10nId='collection-categoryId-'+this.categoryId;return navigator.mozL10n.get(l10nId)||this.name;},refresh:function refresh(){return CollectionsDatabase.get(this.id).then(function create(fresh){this.pinned=fresh.pinned||[];}.bind(this));},rename:function rename(name){this.name=name;this.nonTranslatable=true;return this.write();},save:function save(method){if(this.iconDirty){return this.renderIcon().then(()=>this.write(method),()=>this.write(method));}else{return this.write(method);}},write:function write(method){method=method||'put';var toSave={id:this.id,name:this.name,nonTranslatable:this.nonTranslatable,query:this.query,categoryId:this.categoryId,cName:this.cName,webicons:this.webicons,pinned:this.pinned,background:this.background,icon:this.icon};this.originalProps=toSave;return CollectionsDatabase[method](toSave).then(()=>{this.id=toSave.id;eme.log(this.name,'saved to CollectionsDatabase');});},get iconDirty(){var original=this.originalProps;try{if((original.background&&original.background.blob)!==(this.background&&this.background.blob)){return true;}
var first=this.pinned.concat(this.webResults).slice(0,APPS_IN_ICON);var oFirst=original.pinned.concat(original.webResults).slice(0,APPS_IN_ICON);if(first.length!==oFirst.length){return true;}
for(var i=0;i<APPS_IN_ICON;i++){var item=first[i];var oItem=oFirst[i];if((item&&item.identifier)!==(oItem&&oItem.identifier)){return true;}}}catch(e){eme.error('icon dirty checking failed',e);}
return false;},pin:function pin(){var arg=arguments[0];var items=Array.isArray(arg)?arg:[arg];var newItems=items.filter(this.isNotPinned.bind(this));if(newItems.length){this.pinned=this.pinned.concat(newItems);this.save().then(()=>eme.log(newItems.length,'new pinned to',this.name));}},pinHomeIcons:function pinHomeIcons(identifiers){var items=identifiers.map(function each(identifier){return new PinnedHomeIcon(identifier);});this.pin(items);},dropHomeIcon:function dropHomeIcon(identifier){var newPinned=new PinnedHomeIcon(identifier);for(var i=0,iLen=this.pinned.length;i<iLen;i++){if(this.pinned[i].identifier===identifier){this.pinned.splice(i,1);break;}}
this.pinned.unshift(newPinned);this.save().then(()=>eme.log(identifier,'dropped into',this.name));},pinWebResult:function pinWebResult(data){this.pin(new WebResult(data));},unpin:function unpin(identifier){var idx=this.pinnedIdentifiers.indexOf(identifier);if(idx!==-1){this.pinned.splice(idx,1);return this.save().then(()=>eme.log('removed pinned item',identifier));}},addWebResults:function addWebResult(arrayOfData){var results=arrayOfData.map(function each(data){return new WebResult(data,{isDraggable:false,isRemovable:false});});this.webResults=results;this.webicons=arrayOfData.slice(0,APPS_IN_ICON).map(app=>app.icon);},isPinned:function isPinned(item){return this.pinnedIdentifiers.indexOf(item.identifier)>-1;},isNotPinned:function isNotPinned(item){return!this.isPinned(item);},setPinned:function setPinned(identifiers){this.pinned=identifiers.slice(0,this.pinned.length).map(function(identifier){var idx=this.pinnedIdentifiers.indexOf(identifier);return this.pinned[idx];}.bind(this));this.save();},get pinnedIdentifiers(){return this.pinned.map(function each(item){return item.identifier;});},removeBookmark:function removeBookmark(identifier){window.dispatchEvent(new CustomEvent('collection-remove-webresult',{detail:{identifier:identifier}}));},toGridObject:function(item){var icon;if(item.type==='homeIcon'){if(!HomeIcons.ready){eme.warn('HomeIcons not ready, pinned apps may not render properly');}
icon=HomeIcons.get(item.identifier);}else if(item.type==='webResult'){item.features=item.features||{};item.features.isEditable=false;item.features.search=true;icon=new GaiaGrid.Bookmark(item.data,item.features);if(icon.isRemovable){icon.remove=()=>this.removeBookmark(item.identifier);}}
if(!icon){eme.error(item.identifier,'home icon not found');}
return icon;},addToGrid:function addToGrid(items,grid){items.forEach(function eachResult(item){item.dedupeId=item.identifier;});items=this.dedupe.reduce(items,'fuzzy');items.forEach(function render(item){if(!item||!item.identifier){return;}
var icon=this.toGridObject(item);if(icon){grid.add(icon);}},this);},addItemToGrid:function addItemToGrid(item,grid,position){this.pinned.splice(position,1,new PinnedHomeIcon(item.identifier));grid.add(this.toGridObject(item),position);if(this.pinned.length===1){grid.add(new GaiaGrid.Divider(),1);}
grid.render();this.renderIcon();},renderWebResults:function render(grid){if(!this.webResults.length){return;}
grid.add(new GaiaGrid.Divider());this.addToGrid(this.webResults,grid);grid.render({from:this.pinned.length});},render:function render(grid){this.dedupe.reset();grid.clear();this.addToGrid(this.pinned,grid);if(this.webResults.length){grid.add(new GaiaGrid.Divider());this.addToGrid(this.webResults,grid);}
grid.render();},renderIcon:function renderIcon(){eme.log('rendering icon for',this.name);return Common.prepareAssets(this).then(()=>this.doRenderIcon(),()=>this.doRenderIcon()).catch((e)=>{eme.error('icon rendering failed',e);});},doRenderIcon:function doRenderIcon(){var iconSrcs=this.pinned.slice(0,APPS_IN_ICON).map((item)=>this.toGridObject(item).icon);if(iconSrcs.length<APPS_IN_ICON){var moreIcons=this.webicons.filter((webicon)=>iconSrcs.indexOf(webicon)===-1).slice(0,APPS_IN_ICON-iconSrcs.length);iconSrcs=iconSrcs.concat(moreIcons);}
var bgSrc=(this.background&&this.background.blob)?URL.createObjectURL(this.background.blob):null;var icon=new CollectionIcon({iconSrcs:iconSrcs,bgSrc:bgSrc});return icon.render().then((canvas)=>{this.icon=canvas.toDataURL();});}};function CategoryCollection(props){BaseCollection.call(this,props);this.categoryId=props.categoryId;this.cName=props.cName;}
CategoryCollection.prototype={__proto__:BaseCollection.prototype};CategoryCollection.fromResponse=function cc_fromResponse(categoryIds,responseData){function getIcon(iconId){return responseData.icons[iconId];}
var collections=[];var categories=responseData.categories.filter(function _filter(cat){return categoryIds.indexOf(cat.categoryId)>-1;});for(var i=0,l=categories.length;i<l;i++){var cat=categories[i];var collection=new CategoryCollection({name:cat.query,categoryId:cat.categoryId,cName:cat.canonicalName,webicons:cat.appIds.map(getIcon)});collections.push(collection);}
return collections;};function QueryCollection(props){BaseCollection.call(this,props);this.query=props.query;if(!this.name){this.name=this.query;}}
QueryCollection.prototype={__proto__:BaseCollection.prototype};exports.BaseCollection=BaseCollection;exports.CategoryCollection=CategoryCollection;exports.PinnedHomeIcon=PinnedHomeIcon;exports.QueryCollection=QueryCollection;exports.WebResult=WebResult;})(window);